<!doctype html>
<html lang="en">

  <head>
    <meta charset="utf-8">
    <meta name="author" content="Béton Armé">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="{{ url_for('static', path='/js/vue.js') }}"></script>
    <title>Concrete looper</title>
  </head>

  <body>
    {% raw %}
    <div id="app">
  <button @click="disconnect" v-if="status === 'connected'">Disconnect</button>
  <button @click="connect" v-if="status === 'disconnected'">Connect</button> {{ status }}
  <br /><br />
  <div v-if="status === 'connected'">
    <form @submit.prevent="sendMessage" action="#">
      <input v-model="message"><button type="submit">Send Message</button>
    </form>
    <ul id="logs">
      <li v-for="log in logs" class="log">
        {{ log.event }}: {{ log.data }}
      </li>
    </ul>
  </div>
</div>


    <script>

    const app = new Vue({
      el: "#app",
      data: {
        message: "",
        logs: [],
        status: "disconnected"
      },
      methods: {
        connect() {
          this.socket = new WebSocket("ws://127.0.0.1:8000/ws");
          this.socket.onopen = () => {
            this.status = "connected";
            this.logs.push({ event: "Connected to", data: 'ws://127.0.0.1:8000/ws'})


            this.socket.onmessage = ({data}) => {
              this.logs.push({ event: "Recieved message", data });
            };
          };
        },
        disconnect() {
          this.socket.close();
          this.status = "disconnected";
          this.logs = [];
        },
        sendMessage(e) {
          this.socket.send(this.message);
          this.logs.push({ event: "Sent message", data: this.message });
          this.message = "";
        }
      }
    });

    </script>
    {% endraw %}

  </body>

</html>
